#include "VRML.h"
#include "DataProvider.h"
#include "Timer.h"

#define INT32_T int

extern DataProvider *dp;

int trianglemain(int, OutFile*, int *, int *);

// divider to outnode
#define FACTOR 50.0

OutFile::OutFile() 
{
  nodeCounter = faceCounter = -1;
  root = new SoSeparator;
}

OutFile::~OutFile() 
{
}

void OutFile::writeInitialParams()
{
  SoShapeHints *h = new SoShapeHints;
  h->creaseAngle.setValue(3.14);

  root->addChild(h);
}

void OutFile::writeTextureData(DEM *df)
{
  char buf[256];
  SoTexture2 *texture = new SoTexture2;
  root->addChild(texture);
  strcpy(buf, df->name);
  strcat(buf, ".c.ppm");
  unsigned char *image;
  char c;
  int tdimx, tdimy;
  int i;

  FILE *f = fopen(buf, "rb");
  if (f==NULL) fatal("Cannot open the texture file!");
  // the pgm header -- P5 or sth
  fscanf(f, "%s", &buf);
  fgetc(f);

  if ((c=fgetc(f))=='#') { //comment
    for(; (c=fgetc(f))!='\n'; ) ;
  } else ungetc(c, f);

  // the dimensions: number of columns and the rows, respectively
  fscanf(f, "%d %d", &tdimx, &tdimy);
  fgetc(f);

  if ((c=fgetc(f))=='#') { //comment
    for(; (c=fgetc(f))!='\n'; ) ;
  } else ungetc(c, f);

  // the maximum value -- determines the data element size
  fscanf(f, "%d", &i);
  if (i!=255) {
    fatal("Can only handle rgb 3*255 files");
  }
  // and the last carridge return character
  fgetc(f); 

  // prepare the necessary memory space 
  NewVector(image, 3*tdimx*tdimy, unsigned char);

  // and read the actual data
  int j;
  //  if (tdimx<tdimy) 
  for(i=0; i<tdimy; i++) 
    for(j=0; j<tdimx; j++) {
      int dx = 3*(i*tdimx + tdimx - 1 -j);
      image[dx] = fgetc(f);
      image[dx+1] = fgetc(f);
      image[dx+2] = fgetc(f);
      //      if((image[i]=fgetc(f))==EOF)
      //	fatal("Texture file too short");
    }
  
    
  // just to make sure the file is valid
  //  if (fgetc(f)!=EOF)
  //    fatal("Texture file too long");
  fclose(f);

  


  //  texture->filename.setValue(buf);  ///!!!!! do poprawki!!!!!!!
  texture->image.setValue(SbVec2s(tdimx, tdimy), 3, image);
  delete image; //last addition!!!!
  
  SoTexture2Transform *textr = new SoTexture2Transform;
  root->addChild(textr);
  textr->scaleFactor.setValue(1, 1.0);
  textr->rotation.setValue(1.57);
}

void OutFile::startListOfNodes()
{
  coor = new SoCoordinate3;
}

void OutFile::writeNode(COOR x, COOR y, ELEV z)
{
  coor->point.set1Value(++nodeCounter, SbVec3f(x, z/FACTOR, y));
}

void OutFile::finishListOfNodes()
{
  root->addChild(coor);
}

void OutFile::startListOfFaces()
{
  face = new SoIndexedFaceSet;
}

void OutFile::writeFace(int a, int b, int c)
{
  face->coordIndex.set1Value(++faceCounter,(INT32_T) a);
  face->coordIndex.set1Value(++faceCounter,(INT32_T) b);
  face->coordIndex.set1Value(++faceCounter,(INT32_T) c);
  face->coordIndex.set1Value(++faceCounter, SO_END_FACE_INDEX);
}

void OutFile::finishListOfFaces()
{
  root->addChild(face);
}

void OutFile::finishFile()
{
}

void OutFile::dumpToFile(char *fname)
{
  SoWriteAction myAct;
  FILE *iff;
  iff = fopen(fname, "w+");
  myAct.getOutput()->setBinary(FALSE);
  myAct.getOutput()->setFilePointer(iff);
  myAct.apply(root);
  fclose(iff);
}


void VRMLFile::writeHeader()
{
}

void IVFile::writeHeader()
{
}




///////////////////////


SoSeparator * getURLTerrain(char* elevationFileName, float meshTresh)
{

  Timer *time = new Timer();
  
  SoTerrain *t = new SoTerrain(elevationFileName, meshTresh);

  time->stop("download time");
  

//   info("before getDEM from VRML.C");
  
//   int x, y;

//   char *p = strstr(elevationFileName, ".dem");
//   p--;
//   p--;
   
//   x = *p-'0';
//   p++;
//   y = *p-'0';
  
//   DEM *aDEMData = dp->getDEM(x, y, 2); //////!!!!!!!!!@@@@@

//   info("before SoTerrain constructor mesh is ");

//   SoTerrain *t = new SoTerrain(aDEMData->data, meshTresh, aDEMData->dim); //!!!!!$$$
//   info("after SoTerrain constructor");
  
  //!!!!!!
  t->build();

  return t;
  
  
}
